#include <windows.h>
#include <stdlib.h>
#include <wtypes.h>
#include <conio.h>
#include <stdio.h>
#include "main.h"
 
#define USE_SCAN_DATA_LOG_FILE 1
UINT uiScanRateAvg = 4;
BYTE bNumChans = 6;
double dblRate = 50;
int __cdecl main()
{
	usDevID = 0;  
	printf("\nCalling Init - wait\n");
	Init();
	printf("Done Calling Init\n");
	printf("Calling EX_Connect(...) - wait\n");
	if(!EX_Connect(&usDevID)) { printf("\nStartup failed - any key to exit\n"); getch(); return 0; }
	printf("EX_Connect() success, got dev: %u\n", usDevID);
	while(true) {
		if((!EX_SetScanType (usDevID, MULTI_CHAN_SCAN)) 
			|| (!EX_SetMultiChanScanChans (usDevID, bNumChans)) 
			|| (!EX_SetDataLogOptions (usDevID, SCAN_USE_DATA_ARRAY | USE_SCAN_DATA_LOG_FILE, 0, 0))
			) 
			break; 
		printf("Calling EX_SendRate()\n");
		if(!EX_SendRate ( usDevID , &dblRate ))
		{ printf("EX_SendRate() FAILED - any key to exit\n"); getch(); return 0; }
		else printf("EX_SendRate() success\n");

		printf("Calling EX_Run()\n");
		if(!EX_Run (usDevID)) break; 
		fStartSuccess = TRUE; SetCon(); setMainScreen(); break; 
		printf("EX_Run() success\n");
	} if(!fStartSuccess) { printf("Startup failed - any key to exit\n"); getch(); return 0; } 

	gotoxy(0,16); printf("internal data rate: %2.1lfHz.", dblRate);
	gotoxy(0,17); printf("scanning rate: %2.1lfHz.", dblRate / (bNumChans * 5));
	gotoxy(0,18); printf("average count: %u", uiScanRateAvg);
	gotoxy(0,19); printf("sample rate: %2.1lfHz.", (dblRate / (bNumChans * 5)) / 4.0);

	while(fRunning)
	{
		SleepEx(5, TRUE); //requireed to prevent excessive CPU usage
		EX_CheckScanStatus(usDevID, &puiNumScansRemainingInBuff, &pfStillScanning, &puiStatusCode);
		gotoxy(0,5); printf("Scans in buff: % 3u, StatCode: 0x%03X, StillScanning: %s", puiNumScansRemainingInBuff, puiStatusCode, pfStillScanning > 0 ? "YES" : " NO");
		if(puiNumScansRemainingInBuff > 4)
		{
			uiNumScansToReturn = 4;
			EX_GetScanDataInt (usDevID, piDataBuff, uiNumScansToReturn, TRUE, &puiNumScansReturned, &puiNumScansRemainingInBuff, &pfStillScanning, &puiTotalBuffSize, &puiStatusCode); 
			showData(); if(keyChk()) break;
		}
		if(!pfStillScanning) EndScan();
		if(kbhit()) EndScan();
	}  return 1;
}




//###########################
// Connect thread and related
//###########################

BOOLEAN Init()
{  
	hLib301 = LoadLibrary ("LL_USB2k.dll"); if(!hLib301) return FALSE;
	EX_Connect = (P_DLL_EX_CONNECT)GetProcAddress(hLib301, "EX_Connect");
	if(!EX_Connect) return FALSE;
	EX_SetScanType =  (P_DLL_EX_SET_SCAN_TYPE)GetProcAddress(hLib301, "EX_SetScanType");
	if(!EX_SetScanType) return FALSE;
	EX_SetMultiChanScanChans =  (P_DLL_EX_SET_MULTI_CHAN_SCAN_CHANS)GetProcAddress(hLib301, "EX_SetMultiChanScanChans");
	if(!EX_SetMultiChanScanChans) return FALSE;
	EX_SetDataLogOptions =  (P_DLL_EX_SET_DATA_LOG_OPTIONS)GetProcAddress(hLib301, "EX_SetDataLogOptions");
	if(!EX_SetDataLogOptions) return FALSE;
	EX_Run =  (P_DLL_EX_RUN)GetProcAddress(hLib301, "EX_Run");
	if(!EX_Run) return FALSE;
	EX_CheckScanStatus = (P_DLL_EX_CHECK_SCAN_STATUS)GetProcAddress(hLib301, "EX_CheckScanStatus");
	if(!EX_CheckScanStatus) return FALSE;
	EX_GetScanDataDblDigin =  (P_DLL_EX_GET_SCAN_DATA_DOUBLE_DIGIN)GetProcAddress(hLib301, "EX_GetScanDataDblDigin");
	if(!EX_GetScanDataDblDigin) return FALSE;
	EX_GetScanDataDbl =  (P_DLL_EX_GET_SCAN_DATA_DOUBLE)GetProcAddress(hLib301, "EX_GetScanDataDbl");
	if(!EX_GetScanDataDbl) return FALSE;

	EX_GetScanDataInt =  (P_DLL_EX_GET_SCAN_DATA_INT)GetProcAddress(hLib301, "EX_GetScanDataInt");
	if(!EX_GetScanDataInt) return FALSE;
	EX_SendRate =  (P_DLL_EX_SEND_RATE)GetProcAddress(hLib301, "EX_SendRate");
	if(!EX_SendRate) return FALSE;


	EX_SetMultiChanScanChans_TO_LOG =  (P_DLL_EX_SET_MULTI_CHAN_SCAN_LOG_CHANS)GetProcAddress(hLib301, "EX_SetMultiChanScanChans_TO_LOG");
	if(!EX_SetMultiChanScanChans_TO_LOG) return FALSE;
	EX_Stop =  (P_DLL_EX_STOP)GetProcAddress(hLib301, "EX_Stop");
	if(!EX_Stop) return FALSE;
	EX_StopComplete =  (P_DLL_EX_STOP_COMPLETE)GetProcAddress(hLib301, "EX_StopComplete");
	if(!EX_StopComplete) return FALSE;
    return TRUE;
}




//###############
// Misc functions
//###############
void EndScan(void)
{
	if(!fRunning) return;
	gotoxy(0,17); printf("Completing scan stop - wait...."); gotoxy(0,16); 
	if(!EX_Stop(usDevID)) printf("failed to stop scan run\n"); 
	else { EX_StopComplete(usDevID); printf("\nScan Stopped. Exiting application - please wait\n"); fRunning = FALSE; }
}


  
//#########################
// Screen support functions
//#########################
void setMainScreen(void)
{ system("cls"); printf("\nINITIALIZED\nPress 'E' to end scanning and exit\n" ); }


double LOCAL_RawToVolts(INT iRawCount)
{
    double dblMillivolts = (iRawCount - 8388608)  * 0.00000059604645;
    return dblMillivolts;
}
void doBlockAverage(UINT uiChanCnt, UINT uiAvgCnt, UINT* uiRawArrayIn, UINT* uiCntRawArrayOut)
{
	double* dblRawArrayOut;
	dblRawArrayOut = new double [uiChanCnt];
	UINT uiIndex = 0;
	for(uiIndex = 0; uiIndex < uiChanCnt; uiIndex++) 
		dblRawArrayOut [uiIndex] = 0.0;

	UINT uiOffset = 0; UINT uiChanIndex = 0;
	for(UINT uiAvgCntIndex = 0; uiAvgCntIndex < uiAvgCnt; uiAvgCntIndex++) 
	{
		for(uiChanIndex = 0; uiChanIndex < uiChanCnt; uiChanIndex++) 
		{
			dblRawArrayOut[uiChanIndex] = dblRawArrayOut[uiChanIndex]
				+  (UINT)uiRawArrayIn[uiOffset + uiChanIndex];
		}
		uiOffset += uiChanCnt;
	}
	for(uiChanIndex = 0; uiChanIndex < uiChanCnt; uiChanIndex++) 
		uiCntRawArrayOut [uiChanIndex] = (UINT) dblRawArrayOut [uiChanIndex] / uiAvgCnt;
}


UINT uiCnt = 1;
void showData() 
{

	UINT uiCntRawArrayOut[32];
	UINT* puiCntRawArrayOut = uiCntRawArrayOut;
	doBlockAverage(bNumChans, uiScanRateAvg, (UINT*)piDataBuff, uiCntRawArrayOut);
	gotoxy(0,7); printf("chan 0: % 2.6lf", LOCAL_RawToVolts(uiCntRawArrayOut[0]));
	gotoxy(0,8); printf("chan 1: % 2.6lf", LOCAL_RawToVolts(uiCntRawArrayOut[1]));
	gotoxy(0,9); printf("chan 2: % 2.6lf", LOCAL_RawToVolts(uiCntRawArrayOut[2]));
	gotoxy(0,10); printf("chan 3: % 2.6lf", LOCAL_RawToVolts(uiCntRawArrayOut[3]));

	gotoxy(0,11); printf("chan 4: % 2.6lf", LOCAL_RawToVolts(uiCntRawArrayOut[4]));
	gotoxy(0,12); printf("chan 5: % 2.6lf", LOCAL_RawToVolts(uiCntRawArrayOut[5]));

	gotoxy(0,14); printf("scans / average count : %u", uiCnt); uiCnt++;
}

BOOLEAN keyChk()
{
	if(_kbhit())
	{
		iKeyChar = getch(); cUserInputVal = (char)iKeyChar;
		if((cUserInputVal == 27) || (cUserInputVal == 'E') || (cUserInputVal == 'e'))
		{
			EndScan();
			cUserInputVal=0; return TRUE;
		}
		else { gotoxy(0,18); printf("\ngot key: %c\n", (char)iKeyChar); }
	}
	return FALSE;
}

BOOLEAN SetCon(void)
{
	hOutCon = GetStdHandle(STD_OUTPUT_HANDLE);
	if(!hOutCon)
	{ MessageBox(0, "Error writing to console", "-- error", MB_OK); return FALSE; }
	hInCon =  GetStdHandle(STD_INPUT_HANDLE);
	if(!hInCon) { MessageBox(0, "Error reading from console", "-- error", MB_OK); return FALSE; }
	ConsoleCursorInfo.dwSize=1; ConsoleCursorInfo.bVisible = TRUE; SetConsoleCursorInfo(hOutCon, &ConsoleCursorInfo);
	return TRUE;
}

